# npm-cli-path

[![NPM version](https://img.shields.io/npm/v/npm-cli-path.svg)](https://www.npmjs.com/package/npm-cli-path)
[![Build Status](https://travis-ci.org/shinnn/npm-cli-path.svg?branch=master)](https://travis-ci.org/shinnn/npm-cli-path)
[![Build status](https://ci.appveyor.com/api/projects/status/8osd3at404d3jrxi/branch/master?svg=true)](https://ci.appveyor.com/project/ShinnosukeWatanabe/npm-cli-path/branch/master)
[![Coverage Status](https://img.shields.io/coveralls/shinnn/npm-cli-path.svg)](https://coveralls.io/github/shinnn/npm-cli-path)
[![Dependency Status](https://img.shields.io/david/shinnn/npm-cli-path.svg?label=deps)](https://david-dm.org/shinnn/npm-cli-path)
[![devDependency Status](https://img.shields.io/david/dev/shinnn/npm-cli-path.svg?label=devDeps)](https://david-dm.org/shinnn/npm-cli-path#info=devDependencies)

Resolve the path of [`npm-cli.js`]() included in the globally installed npm CLI

```javascript
const npmCliPath = require('npm-cli-path');

npmCliPath().then(result) => {
  result; //=> '/usr/local/lib/node_modules/npm/bin/npm-cli.js'
});
```

## Installation

[Use npm.](https://docs.npmjs.com/cli/install)

```
npm install npm-cli-path
```

## API

```javascript
const npmCliPath = require('npm-cli-path');
```

### npmCliPath()

Return: [`Promise`](http://www.ecma-international.org/ecma-262/6.0/#sec-promise-constructor) instance

It finds the first instance of the given executable in the [PATH](http://pubs.opengroup.org/onlinepubs/000095399/basedefs/xbd_chap08.html#tag_08_03) environment variable, expands all symbolic links and resolves the canonicalized absolute pathname.

```javascript
'use strict';

const path = require('path');
const npmCliPath = require('npm-cli-path');

npmCliPath('foo', {
  path: 'binaries',
  cache: {
    [path.resolve('binaries/foo')]: '/usr/local/lib/node_modules/foo/bin/foo'
  }
}).then((err, resolvedPath) => {
  resolvedPath; //=> '/usr/local/lib/node_modules/foo/bin/foo'
}, console.error);
```

## License

Copyright (c) 2015 [Shinnosuke Watanabe](https://github.com/shinnn)

Licensed under [the MIT License](./LICENSE).

[npm-cli]: https://github.com/npm/npm/blob/master/bin/npm-cli.js
